import regsub, string, regex
#import termios, TERMIOS, sys
import data, player

# telnet protocol variables
IAC  = chr(255)	# Interpret as command
DONT = chr(254)
DO   = chr(253)
WONT = chr(252)
WILL = chr(251)

# whether echo is on
echo = 1

# see if anything from the mud triggered an action/gag/sub
# if so, handle it.  
# then display stuff from the mud to the user
def HandleMudOutput(output, ses):
    if not output:
	return
    if not string.split(output):
	return # just whitespace
    if len(output) >= data.BUFSIZE:
	print 'HUGE INPUT!!!'

    # I st... er 'adopted' this code from 'telnet.py', which comes with
    # the python distribution.

    iac = 0	# Interpret next char as command
    opt = ''	# Interpret next char as option
    cleandata = ''
    for c in output:
	if opt:
	    opt = ''
	elif iac:
	    iac = 0
	    if c == IAC:
		cleandata = cleandata + c
	    elif c in (DO, DONT):
		if c == DO: print '(DO)',
		else: print '(DONT)',
		opt = IAC + WONT
	    elif c in (WILL, WONT):
		if c == WILL: 
		    # turn off echo
		    # OffEcho() my lab's damn sgi's don't support termios
		    pass
		else:
		    # turn on echo
		    # OnEcho() my lab's damn sgi's don't support termios
		    pass
	    else:
		pass # print '(command)', ord(c)
	elif c == IAC:
	    iac = 1
	else:
	    cleandata = cleandata + c
	    
    if cleandata:
	ses.log(cleandata)
	if ses.CheckForGaggedText(cleandata):
	    # whoa, this text is special; it's been gagged.
	    # this is handled by splitting the text into lines, then
	    # removing the line with the offending text
	    gl = string.splitfields(cleandata, '\r')
	    rebuild = []
	    for line in gl:
		if ses.CheckForGaggedText(line):
		    pass
		else:
		    rebuild = rebuild + [line]
	    cleandata = string.joinfields(rebuild, '\r')
	# handle substitutes
	for sub in ses.subs.keys():
	    if regex.search(sub, cleandata) != -1:
		cleandata = regsub.gsub(sub, ses.subs[sub], cleandata)
	# display the text if this is the current session
	if ses is data.currsession and ses.connected:
	    log(cleandata)
	    if cleandata[-1] == '\n' or cleandata[-1] == '\r':
		player.PutReallyUntouchedLine(cleandata)
	    else:
		player.PutUntouchedLine(cleandata)
		
	# add output to the session's databuffer
	ses.databuf.add(cleandata)
	# Handle actions triggered by mud output
	oldses = data.currsession
	data.currsession = ses
	ses.CheckActions(cleandata)
	data.currsession = oldses

# log some text
def log(str):
    data.logfile.write("*** Logging ***\n")
    data.logfile.writelines( [str, "\n"] )

# turn on echo
def OnEcho():
    global echo
    if echo:
	raise 'lt_echo_error', 'echo should not be on'
    echo = 1
    fd = sys.stdin.fileno()
    new = termios.tcgetattr(fd)
    new[3] = new[3] & TERMIOS.ECHO          # lflags
    try:
	termios.tcsetattr(fd, TERMIOS.TCSADRAIN, new)
    except:
	raise 'lt_echo_error', 'unable to turn off echo'

# turn off echo
def OffEcho():
    global echo
    if not echo:
	raise 'lt_echo_error', 'echo should not be off'
    echo = 0
    fd = sys.stdin.fileno()
    new = termios.tcgetattr(fd)
    new[3] = new[3] & ~TERMIOS.ECHO          # lflags
    try:
	termios.tcsetattr(fd, TERMIOS.TCSADRAIN, new)
    except:
	raise 'lt_echo_error', 'unable to turn off echo'


